DAT programName         byte "Max7219Demo140116e", 0
CON
{{
  ******* Public Notes *******

  Author: Duane Degn
  Date: December 26, 2013
  Updated: January 16, 2014
  
  MIT License

  An attempt to control an 8x8 LED array with a MAX7219 chip.

  The number of arrays may be changed by changing the
  "ARRAYS_IN_USE" constant.

  For now, this demo and object will successfully
  scroll text on ICStation 8x8 arrays.

  I do not presently have the "Eyes" section of the
  code working yet.

  The constants marked with "User changeable" may be
  changed based on the LED project is configured.
  
  I stopped working on this code once I got text
  to scroll. There are several things in the
  child object which bother me which I hope to
  change in the future.

  There are portions of the child object which work
  but which I don't understand why the code works.

  I don't think I'm clear enough in my head about how
  the pixels are being stored in the RAM.

  The method "ShiftColumnOtherWay" was a desperate attempt
  to get the display to scroll correctly. I don't
  understand why it works. I'd think the method
  "ShiftColumn" should have done the job.

  The code in this program is pretty much all original.
  I did look at Hover1's 7-segment MAX7219 code. Which
  helped get me started.
 
}}
{
  ******* Private Notes *******

   131225c Displays a message one character at a time.
   25c Appears to be working.
   25d Change font with each message.
   25e Try to rotate text.
   25e Didn't work.
   25g Rotation worked.
   25h Try to add scrolling.
   25j Working reasonably well.
   25k Seems to scroll single rotated array correctly.
   25l Try adding additional array.
   25l Doesn't work. The two displays are almost the
   same. Both have lots of glitches.
   25m Better but a lot of noise on the last display.
   25n Much worse.
   25o Abandon 25n.
   26a Start moving MAX7219 specific code to a
   child object.
   26a Appears to work correctly.
   26b Make the split.
   26b Appears to work correctly using the child
   object "Max7219MultiArray131226b".
   26c Start adding a few features.
   26d Start adding input and eyes.
   140116b Works reasonably well with two
   arrays (ICStation).
   26d Input doesn't really work. The input buffer
   isn't checked frequently enough to have much
   control. The input really needs to be checked
   with a separate cog. I'll add this if there
   is enough interest (from myself and/or others).
   26e Try to fix the way characters are added
   to scroll in child object.
   26e Brightness only goes up to 15, not 31.
   
}
CON ' Parent Constants                    
                     
  _clkmode = xtal1 + pll16x 
  _xinfreq = 5_000_000

  CS_PIN = 18                   '' User changeable
  DATA_PIN = 17                 '' User changeable
  CLOCK_PIN = 16                '' User changeable

  ARRAYS_IN_USE = 4 '2             '' User changeable
  DEBUG_BAUD = 115_200          '' User changeable
  
  QUOTE = 34

  DEFAULT_EYE_DEMO_INTERVAL = 2000
  
  #0, MAIN_MENU, DEMO_MENU, EYES_MENU
  
  DEFAULT_MENU = DEMO_MENU

  #0, DEMO_DISPLAY, EYES_DISPLAY

  DEFAULT_DISPLAY = DEMO_DISPLAY

  #0, TEXT_DEMO, EYES_DEMO, ALTERNATE_DEMO
  DEFAULT_DEMO = TEXT_DEMO 'ALTERNATE_DEMO
      
VAR

  long eyeDemoInterval, demoTimer, scrollDelay
  long delayChange
  
  byte arrayBuffer[Leds#LINES_IN_ARRAY * ARRAYS_IN_USE]
  byte activeMenu, previousMenu, activeDisplay
  byte activeDemo, rotatedFlag
  byte adjustableSpeedFlag, brightness

OBJ

  Pst : "Parallax Serial Terminal" 'Dat"                      ' uses one cog
  Leds : "Max7219MultiArray140116e"
  
PUB Setup

  Pst.Start(DEBUG_BAUD)

  activeMenu := DEFAULT_MENU
  previousMenu := 255
  activeDisplay := DEFAULT_DISPLAY
  activeDemo := DEFAULT_DEMO
  rotatedFlag := 0
  adjustableSpeedFlag := 1
  delayChange := 1
  eyeDemoInterval := (clkfreq / 1000) * DEFAULT_EYE_DEMO_INTERVAL
  
  Leds.Init(CLOCK_PIN, DATA_PIN, CS_PIN, ARRAYS_IN_USE, @arrayBuffer, 1)
  waitcnt(clkfreq * 2 + cnt) ' time to open terminal window

  brightness := Leds.SetBrightness(Leds#DEFAULT_BRIGHTNESS)
  scrollDelay := Leds.SetScrollDelay(Leds#DEFAULT_SCROLL_INTERVAL)
  '' Set brightness and delay in child object.
  '' The input to this object is very very slow.
  
  MainLoop
  
PUB MainLoop 
   
  repeat
    CheckMenu
    result := Pst.RxCount
    if result
      CheckInput
    case activeDisplay
      DEMO_DISPLAY:
        Demo
      EYES_DISPLAY:
        Eyes
        
PUB CheckInput

  result := Pst.RxCount
  if result
    result := Pst.CharIn
    CheckCommonInputs(result)

PUB CheckCommonInputs(localCharacter)

  case localCharacter
    "c", "C":
      Pst.Clear
      DisplayMenu
    "m", "M":
      activeMenu := MAIN_MENU  
    "+":
      brightness := Leds.SetBrightness(brightness + 1)
    "-":
      brightness := Leds.SetBrightness(brightness - 1)
    "*": ' scroll faster
      scrollDelay := Leds.SetScrollDelay(scrollDelay - delayChange)
      delayChange := (scrollDelay / 20) + 1
    "/": ' scroll slower
      scrollDelay := Leds.SetScrollDelay(scrollDelay + delayChange)
      delayChange := (scrollDelay / 20) + 1
    "f":
      scrollDelay := Leds.SetScrollDelay(25)
      delayChange := (scrollDelay / 20) + 1
      NewLine
      Pst.Str(string("full speed scrollDelay = "))
      Pst.Dec(scrollDelay)
    "q":
      scrollDelay := Leds.SetScrollDelay(50)
      delayChange := (scrollDelay / 20) + 1
      NewLine
      Pst.Str(string("quick speed scrollDelay = "))
      Pst.Dec(scrollDelay)
    "n":
      scrollDelay := Leds.SetScrollDelay(100)
      delayChange := (scrollDelay / 20) + 1
      NewLine
      Pst.Str(string("average speed scrollDelay = "))
      Pst.Dec(scrollDelay)
    "l":
      scrollDelay := Leds.SetScrollDelay(200)
      delayChange := (scrollDelay / 20) + 1
      NewLine
      Pst.Str(string("low speed scrollDelay = "))
      Pst.Dec(scrollDelay)
    "F":
      brightness := Leds.SetBrightness(Leds#MAX_BRIGHTNESS)
      NewLine
      Pst.Str(string("max brightness = "))
      Pst.Dec(brightness)
    "A":
      brightness := Leds.SetBrightness(Leds#HALF_BRIGHTNESS)
      Pst.Str(string("half brightness = "))
      Pst.Dec(brightness)
    "E":
      brightness := Leds.SetBrightness(Leds#EIGHTH_BRIGHTNESS)
      Pst.Str(string("eighth brightness = "))
      Pst.Dec(brightness)  
    "Q":
      brightness := Leds.SetBrightness(Leds#QUARTER_BRIGHTNESS)
      Pst.Str(string("quarter brightness = "))
      Pst.Dec(brightness) 
    "Z":
      brightness := Leds.SetBrightness(Leds#MIN_BRIGHTNESS)
      Pst.Str(string("zero brightness = "))
      Pst.Dec(brightness) 
    {"0".."9":
      localCharacter -= "0"
      brightness := Leds.SetBrightness(6 + localCharacter)
      Pst.Str(string("# brightness = "))
      Pst.Dec(brightness) } 
PUB CheckMenu

  if previousMenu <> activeMenu
    DisplayMenu
    previousMenu := activeMenu
     
PUB DisplayMenu

  CommonMenu0

  case activeMenu
    MAIN_MENU:
      MainMenu
    DEMO_MENU:
      DemoMenu
    EYES_MENU:
      EyesMenu
      
PRI CommonMenu0

  Pst.Home
  NewLine
  Pst.Str(string(" Program Name = ", QUOTE))
  Pst.Str(programName)
  Pst.Char(QUOTE)
  NewLine
  Pst.Str(string(" LED Object Name = ", QUOTE))
  Pst.Str(Leds.GetObjectName)
  Pst.Char(QUOTE)
  NewLine
  NewLine
    
PRI CommonMenu1
  
  Pst.Str(@menuText)
  NewLine
  NewLine
  Pst.Str(@menuSelect)
  NewLine 
 
PRI CommonMenu2

  NewLine
  Pst.Str(string(" Press ", QUOTE, "c", QUOTE, " to refresh screen."))
  NewLine
  NewLine
    
PRI MainMenu

  Pst.Str(string(" Main"))
  CommonMenu1
  Pst.Str(@menuMain)
  
PRI DemoMenu


  Pst.Str(string(" Demo"))
  CommonMenu1
  Pst.Str(@menuDemo)
  NewLine
  Pst.Str(@menuReturn)
  
PRI EyesMenu

  Pst.Str(string(" Eyes"))
  CommonMenu1
  Pst.Str(@menuEyes)
  NewLine
  Pst.Str(@menuReturn)
  
PUB Demo

  case activeDemo
    TEXT_DEMO:
      DemoText
    EYES_DEMO:
      DemoEyes
    ALTERNATE_DEMO:
      DemoText
      if Pst.RxCount
        return
      DemoEyes

PUB DemoText
      
  Leds.SetFont(Leds#FREE_DESIGN)
  if rotatedFlag
    Leds.ScrollRotatedText(@message0)
  else
    NewLine
    Pst.Str(string("Leds.ScrollText(@message0)")) 
    Leds.ScrollText(@message0) 
  if Pst.RxCount
    return
  Leds.SetFont(Leds#ASCII_0508)
  if rotatedFlag
    Leds.ScrollRotatedText(@message0)
  else
    Leds.ScrollText(@message0)
    
PUB DemoEyes | eyeIndex

  demoTimer := cnt + eyeDemoInterval
  repeat eyeIndex from 0 to Leds#MAX_EYE_INDEX
    Leds.DisplayRotatedEye(eyeIndex)
    if Pst.RxCount
      quit
    waitcnt(demoTimer)
    demoTimer += eyeDemoInterval
    
PUB Eyes

PUB NewLine

  Pst.ClearEnd
  Pst.Newline
  
DAT


menuSelect              byte " Please Choose One of the Following Options", Pst#CE, 13
                        byte " m) return to the Main menu.", Pst#CE, 13
                        byte " c) Clear screen.", Pst#CE, 13
                        byte " +) increase brightness one level (slow).", Pst#CE, 13
                        byte " -) decrease brightness one level (slow).", Pst#CE, 13
                        byte " *) increase scroll rate (slow).", Pst#CE, 13
                        byte " /) decrease scroll rate (slow).", Pst#CE, 13
                        byte " f) Full speed scroll (20ms delay).", Pst#CE, 13
                        byte " q) Quick speed scroll (50ms delay).", Pst#CE, 13
                        byte " n) Normal speed scroll (100ms delay).", Pst#CE, 13
                        byte " l) Low speed scroll (200ms delay).", Pst#CE, 13
                        byte " F) Full brightness.", Pst#CE, 13
                        byte " A) Average (half) brightness.", Pst#CE, 13
                        byte " Q) Quarter brightness.", Pst#CE, 13
                        byte " E) Eighth brightness.", Pst#CE, 13
                        byte " Z) Zero brightness (lowest setting).", Pst#CE, 13, 0
    
menuReturn              byte " x) Return to the main menu.", 0

menuMain                byte " d) switch to Demo menu", 13
                        byte " e) switch to Eye menu", 13
                        byte " t) switch to Text menu", 0 

menuDemo                byte " a) Alternating demo", 13
                        byte " e) Eye demo", 13
                        byte " t) Text demo", 0

menuEyes

menuText                byte " Menu", 0

DAT

'message0                byte "Merry Christmas  ", 0
message0                byte "ICStation 8x8 LED Arrays  ", 0